﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Cvicenie9b
{
    public partial class Form1 : Form
    {
        private Bitmap bitmap;
        private Point point;
        private Color color = Color.Black;
        private int width = 2;

        public Form1()
        {
            InitializeComponent();
            bitmap = new Bitmap(pictureBox1.Width, pictureBox1.Height);
            using (Graphics graphics = Graphics.FromImage(bitmap))
            {
                graphics.Clear(Color.White);
            }
        }

        private void openToolStripButton_Click(object sender, EventArgs e)
        {
            OpenFileDialog dialog = new OpenFileDialog();
            dialog.Filter = "JPG Image (*.jpg)|*.jpg|PNG Image (*.png)|*.png";
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                Image image = Image.FromFile(dialog.FileName);
                using (Graphics graphics = Graphics.FromImage(bitmap))
                {
                    graphics.DrawImage(image, 0, 0);
                }
                pictureBox1.Invalidate();
            }
        }

        private void pictureBox1_Paint(object sender, PaintEventArgs e)
        {
            e.Graphics.DrawImage(bitmap, 0, 0);
        }

        private void saveToolStripButton_Click(object sender, EventArgs e)
        {
            SaveFileDialog dialog = new SaveFileDialog();
            dialog.Filter = "PNG Image (*.png)|*.png";
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                bitmap.Save(dialog.FileName);
            }
        }

        private void pictureBox1_MouseMove(object sender, MouseEventArgs e)
        {
            positionLabel.Text = "X=" + e.X + " Y=" + e.Y;

            if (e.Button == MouseButtons.Left)
            {
                using (Graphics graphics = pictureBox1.CreateGraphics())
                {
                    graphics.DrawImage(bitmap, 0, 0);
                    graphics.DrawLine(new Pen(color, width), point.X, point.Y,
                        e.X, e.Y);
                }
            }
        }

        private void pictureBox1_MouseDown(object sender, MouseEventArgs e)
        {
            point = new Point(e.X, e.Y);
        }

        private void pictureBox1_MouseUp(object sender, MouseEventArgs e)
        {
            using (Graphics graphics = Graphics.FromImage(bitmap))
            {
                graphics.DrawLine(new Pen(color, width), point.X, point.Y,
                    e.X, e.Y);
            }
            pictureBox1.Invalidate();
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void optionsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ColorDialog dialog = new ColorDialog();
            dialog.Color = color;
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                color = dialog.Color;
            }
        }

        private void changeWidthToolStripMenuItem_Click(object sender, EventArgs e)
        {
            WidthForm widthForm = new WidthForm();
            if (widthForm.ShowDialog() == DialogResult.OK)
            {
                width = widthForm.width;
            }
        }

        private void copyToolStripButton_Click(object sender, EventArgs e)
        {
            Clipboard.SetImage(bitmap);
        }

        private void pasteToolStripButton_Click(object sender, EventArgs e)
        {
            Image image = Clipboard.GetImage();
            if (image == null)
            {
                return;
            }
            using (Graphics graphics = Graphics.FromImage(bitmap))
            {
                graphics.DrawImage(image, 0, 0);
            }
            pictureBox1.Invalidate();
        }
    }
}
